rm(list=ls(all=TRUE))
#m=function(x) sin(x) #model1,hetero1
#m=function(x) .8*log(x^2*3+1)#model2
#m=function(x) -.5*exp(-50*x^2)*x #model3
m=function(x) .75*x #hetero2
#v=function(x) 1 
#v=function(x) sqrt(.5+.25*x^2)#hetero1
v=function(x) .15*x+1 #hetero2
lbs=function(f,g,n){
  u=rep(0,n)
    temp=rep(0,n+100)
    temp[1]=1
    e=rnorm((n+100),0,1)
    for (i in 1:(n+99)){
      temp[i+1]=f(temp[i])+g(temp[i])*e[i+1]
    }
    u=temp[101:(n+100)]
    while((u[n]>mean(u)+2*sd(u))||(u[n]<mean(u)-2*sd(u))){
      ## If Xn is an outlier, 
      ##the denominator of the estimation of the conditional distribution of X_{n+1} or X_{n+1}* gvien Xn=Xn or Xn*=Xn would be 0
      temp[1]=1
      e=rnorm((n+100),0,1)
      for (i in 1:(n+99)){
        temp[i+1]=f(temp[i])+g(temp[i])*e[i+1]
      }
      u=temp[101:(n+100)]
    }
  
  x=u[1:(n-1)]
  y=u[2:n]
  
#####################choose h###################################################
  gauss <- function(x) 1/sqrt(2*pi) * exp(-(x^2)/2)
  truncate=as.numeric(integrate(Vectorize(gauss),-5,5)[1])
  W=function(x){
    return ( gauss(x)/truncate*as.numeric(x<=5 & x>=-5))
  }  
  chooseh=function(x,y,nstep=20,bmax=0){
    if (bmax==0){bmax<-sd(x)}
    hp=bmax/nstep*1:nstep
    sumvar=rep(0,nstep)
    for(i in 1:nstep){
      for(j in 1:length(x)){
        sumvar[i]=(sum(gauss((x[j]-x[-j])/hp[i])*y[-j]/sum(gauss((x[j] - x[-j])/hp[i])))-y[j])^2+sumvar[i]
      }   
    }
    h=hp[order(sumvar)][1]
    return(h)
  }
  h=chooseh(x,y)
  fvhat=sum(W((u[n]-x)/h)*y/sum(W((u[n] - x)/h)))
  #########generate one-step ahead or backward value ########################
  generate=function(x,y,condx){
    p=W((condx-x)/h)/sum(W((condx - x)/h))#transition density
    len=length(x)
    cp=rep(0,len)#cumulative transition density
    for (i in 1:len){
      cp[i]=sum(p[1:i])
      while(is.na(cp[i])) return(NA)
    }
    z=runif(1)
    j=1
    while(cp[j]<z) j=j+1
    return(y[j])
  }
  
  bh=chooseh(y,x)
  bgenerate=function(x,y,condx){
    p=W((condx-x)/bh)/sum(W((condx - x)/bh))#transition density
    len=length(x)
    cp=rep(0,len)#cumulative transition density
    for (i in 1:len){
      cp[i]=sum(p[1:i])
      while(is.na(cp[i])) return(NA)
    }
    z=runif(1)
    j=1
    while(cp[j]<z) j=j+1
    return(y[j])
  }

##################generate xstar forward#########################
  bootstrap=function(x,y){
    ustar=rep(0,n)
    ustar[1]=sample(u,1)
    for (i in 1:(n-1)){
      ustar[i+1]=generate(x,y,ustar[i])
    }
    fvstar=generate(x,y,u[n])
    list(ustar=ustar,fvstar=fvstar)
  }

  ##############generate xstar backward#####################
  bbootstrap=function(x,y){
    ustar=rep(0,n)
    ustar[n]=u[n]
    for (i in 1:(n-1)){
      ustar[n-i]=bgenerate(y,x,ustar[n-i+1])
      while(is.na(ustar[n-i])){
        if(i==1){ustar[n-1]=bgenerate(y,x,u[n])}
        if(i==2){
          ustar[n-1]=bgenerate(y,x,u[n])
          ustar[n-2]=bgenerate(y,x,ustar[n-1])                    
        }
        if(i>2){
          ustar[n-i+2]=bgenerate(y,x,ustar[n-i+3])
          ustar[n-i+1]=bgenerate(y,x,ustar[n-i+2])
          ustar[n-i]=bgenerate(y,x,ustar[n-i+1]) 
        }
      }
    }
    fvstar=generate(x,y,u[n])
    list(ustar=ustar,fvstar=fvstar)
  }
  
  ##################forward#################################
 
  fvstarhat=rep(0,250)
  fvstar=rep(0,250)
  for (i in 1:250){
    result=bootstrap(x,y)
    ustar=result$ustar
    xstar=ustar[1:(n-1)]
    ystar=ustar[2:n]
    fvstarhat[i]=sum(W((u[n]-xstar)/h)*ystar/sum(W((u[n] - xstar)/h)))
    fvstar[i]=result$fvstar
  }
  
  ####################backward####################################
  bfvstarhat=rep(0,250)
  bfvstar=rep(0,250)
  for (i in 1:250){
    result=bbootstrap(x,y)
    ustar=result$ustar
    xstar=ustar[1:(n-1)]
    ystar=ustar[2:n]
    bfvstarhat[i]=sum(W((u[n]-xstar)/h)*ystar/sum(W((u[n] - xstar)/h)))
    bfvstar[i]=result$fvstar
  }
  
  
  
  #####################coverage & intervel width##############################
  truevalue=rep(0,1000)
  for (i in 1:1000){
    e=rnorm(1)
    truevalue[i]=f(u[n])+g(u[n])*e
  }
  
  #forward coverage
  interval=fvstar-fvstarhat
  interval=interval[!is.na(interval)]
  q=quantile(interval,c(0.025,.975))
  up=q[2]
  down=q[1]
  flength=up-down
  k=0
  for (i in 1:1000){
    if((truevalue[i]<fvhat+up) & (truevalue[i]>fvhat+down))
      k=k+1
  }
  fc=k/1000
  
  q=quantile(interval,c(0.05,.95))
  up=q[2]
  down=q[1]
  flength90=up-down
  k=0
  for (i in 1:1000){
    if((truevalue[i]<fvhat+up) & (truevalue[i]>fvhat+down))
      k=k+1
  }
  fc90=k/1000
  #backward coverage
  binterval=bfvstar-bfvstarhat
  binterval=binterval[!is.na(binterval)]
  q=quantile(binterval,c(0.025,.975))
  up=q[2]
  down=q[1]
  blength=up-down
  k=0
  for (i in 1:1000){
    if((truevalue[i]<fvhat+up) & (truevalue[i]>fvhat+down))
      k=k+1
  }
  bc=k/1000
  
  q=quantile(binterval,c(0.05,.95))
  up=q[2]
  down=q[1]
  blength90=up-down
  k=0
  for (i in 1:1000){
    if((truevalue[i]<fvhat+up) & (truevalue[i]>fvhat+down))
      k=k+1
  }
  bc90=k/1000
  
  #plot(density(truevalue-fvhat),type='l',main='bootstrape root vs true root',xlab='root',ylab='density')
  #lines(density(interval),col=2)
  #lines(density(binterval),col=3)
  
  list(fc=fc,bc=bc,fl=flength,bl=blength,
       fc90=fc90,bc90=bc90,fl90=flength90,bl90=blength90)
}
n=100
fc=rep(NA,500)
fc90=rep(NA,500)
fl=rep(NA,500)
fl90=rep(NA,500)
bc=rep(NA,500)
bc90=rep(NA,500)
bl=rep(NA,500)
bl90=rep(NA,500)
for (i in 1:500){
  set.seed(5*i)
  ##########generate original data#########################
  results=lbs(m,v,n)
  fc[i]=results$fc
  bc[i]=results$bc
  fl[i]=results$fl
  bl[i]=results$bl
  fc90[i]=results$fc90
  bc90[i]=results$bc90
  fl90[i]=results$fl90
  bl90[i]=results$bl90
  save.image("../workspace/hetero2_normal100.RData")
  print(i)
}
mean(fc)
mean(bc)
mean(fl)
mean(bl)
sqrt(var(fl))
sqrt(var(bl))
mean(fc90)
mean(bc90)
mean(fl90)
mean(bl90)
sqrt(var(fl90))
sqrt(var(bl90))