mfbs=function(f,g,n){
  ###################simulation############################
  u=rep(0,n)
  temp=rep(0,n+100)
  temp[1]=1
  e=rnorm((n+100),0,1)
  for (i in 1:(n+99)){
    temp[i+1]=f(temp[i])+g(temp[i])*e[i+1]
  }
  u=temp[101:(n+100)]
  x=u[1:(n-1)]
  y=u[2:n]
  b=crossval(x,y)
  while((u[n]>mean(u)+2*sd(u))||(u[n]<mean(u)-2*sd(u))||length(b)==0)
  {
    temp[1]=1
    e=rnorm((n+100),0,1)
    for (i in 1:(n+99)){
      temp[i+1]=f(temp[i])+g(temp[i])*e[i+1]
    }
    u=temp[101:(n+100)]
    x=u[1:(n-1)]
    y=u[2:n]
    b=crossval(x,y)
  }
  

  #########################get u###############################
  v=getU(x,y,b)
  ########################fitted future value##################
  w=dnorm((x-u[n]),mean=0,sd=(0.37*b))
  yfhat=mean(uniformize(y,v,inverse=TRUE,w=w))
  ############################bootstrap##########################
  boots=function(u,v){
    vstar=sample(v,n+100,replace=TRUE)
    temp=rep(0,100+n)
    temp[1]=sample(u,1)
    for (i in 1:(n+99)){
      w=dnorm((x-temp[i]),mean=0,sd=(0.37*b))
      temp[i+1]=uniformize(y,vstar[i+1],inverse=TRUE,w=w)
    }
    ustar=temp[101:(100+n)]
    list(ustar=ustar,vstar=vstar[(101):(100+n)])
  }
  ##############################get bootroot##########################
  wf=dnorm((x-u[n]),mean=0,sd=0.37*b)
  yfstar=rep(0,250)
  yfstarhat=rep(0,250)
  for (i in 1:250){
    yfstar[i]=uniformize(y,sample(v,1),inverse=TRUE,w=wf)
    result=boots(u,v)
    ustar=result$ustar
    xstar=ustar[1:(n-1)]
    ystar=ustar[2:n]
    vstar=result$vstar
    wfstar=dnorm((xstar-u[n]),mean=0,sd=0.37*b)
    yfstarhat[i]=mean(uniformize(ystar,vstar,inverse=TRUE,w=wfstar))
  }
  ###########################predictive u##############################
  prev=getU(x,y,b,delete=TRUE)
  prev=prev[1-prev>10^(-6) & prev!=0]
  w=dnorm((x-u[n]),mean=0,sd=(0.37*b))
  yfhat1=mean(uniformize(y,prev,inverse=TRUE,w=w))
  
  wf=dnorm((x-u[n]),mean=0,sd=0.37*b)
  yfstar1=rep(0,250)
  yfstarhat1=rep(0,250)
  for (i in 1:250){
    yfstar1[i]=uniformize(y,sample(prev,1),inverse=TRUE,w=wf)
    result=boots(u,prev)
    ustar=result$ustar
    xstar=ustar[1:(n-1)]
    ystar=ustar[2:n]
    vstar=result$vstar
    wfstar=dnorm((xstar-u[n]),mean=0,sd=0.37*b)
    yfstarhat1[i]=mean(uniformize(ystar,vstar,inverse=TRUE,w=wfstar))
  }
#####################coverage level##################################
  truevalue=rep(0,1000)
  for (i in 1:1000){
    truevalue[i]=f(u[n])+g(u[n])*rnorm(1,0,1)
  }
  interval=yfstar-yfstarhat
  q=quantile(interval,c(0.025,.975),na.rm=TRUE)
  up=q[2]
  down=q[1]
  length=up-down
  k=0
  for (i in 1:1000){
    if((truevalue[i]<yfhat+up) & (truevalue[i]>yfhat+down))
    k=k+1
  }
  c=k/1000

  q=quantile(interval,c(0.05,.95),na.rm=TRUE)
  up=q[2]
  down=q[1]
  length90=up-down
  k=0
  for (i in 1:1000){
    if((truevalue[i]<yfhat+up) & (truevalue[i]>yfhat+down))
    k=k+1
  }
  c90=k/1000
###############predictive#####################
  interval1=yfstar1-yfstarhat1
  interval1=interval1[!is.na(interval1)]
  q=quantile(interval1,c(0.025,.975),na.rm=TRUE)
  up=q[2]
  down=q[1]
  length1=up-down
  k=0
  for (i in 1:1000){
    if((truevalue[i]<yfhat1+up) & (truevalue[i]>yfhat1+down))
    k=k+1
  }
  c1=k/1000

  q=quantile(interval1,c(0.05,.95),na.rm=TRUE)
  up=q[2]
  down=q[1]
  length190=up-down
  k=0
  for (i in 1:1000){
    if((truevalue[i]<yfhat1+up) & (truevalue[i]>yfhat1+down))
    k=k+1
  }
  c190=k/1000

##############################plots##################################
  plot(density(truevalue),type='l')
  lines(density(interval+yfhat,na.rm=TRUE),col=2)
  lines(density(interval1+yfhat1,na.rm=TRUE),col=3)

  list(regc=c,prec=c1,regl=length,prel=length1,regc90=c90,prec90=c190,regl90=length90,prel90=length190)
}

