mkv=function(m,v,n){
##########generate original data#########################
  u=rep(0,n)
  temp=rep(0,n+100)
  temp[1]=1
  e=rlaplace((n+100),0,1/sqrt(2))
  for (i in 1:(n+99)){
    temp[i+1]=m(temp[i])+v(temp[i])*e[i+1]
  }
  u=temp[101:(n+100)]
  while((u[n]>mean(u)+2*sd(u))||(u[n]<mean(u)-2*sd(u)))
  {## If Xn is an outlier, 
    ##the denominator of the estimation of the transition distribution of X_{n+1} or X_{n+1}* gvien Xn=Xn or Xn*=Xn would be 0    
    temp[1]=1
    e=rlaplace((n+100),0,1/sqrt(2))
    for (i in 1:(n+99)){
      temp[i+1]=m(temp[i])+v(temp[i])*e[i+1]
    }
    u=temp[101:(n+100)]
  }
  x=u[1:(n-1)]
  y=u[2:(n)]
  
###############f(x,y)and f(x|y)#####################
  gauss <- function(x) 1/sqrt(2*pi) * exp(-(x^2)/2)
  h=.9*min(sd(u),(quantile(u)[4]-quantile(u)[2])/1.34)*n^(-1/4)  

  fx=function(a) sum (gauss((a - x)/h)/((n-1)*h))
  fxy=function(a,b) sum(gauss((a - x)/h)*gauss((b-y)/h)/((n-1) * h^2))
  f=function(a,b) fxy(a,b)/fx(a) #transition density f(b|a)

###############predicted value#####################
  minu=min(u)-3*h
  maxu=max(u)+3*h
  xf=function(y) y*f(u[n],y)
  fvhat=as.numeric(integrate(Vectorize(xf),minu,maxu)[1])
  
#########generate x1, one-step ahead and back value ########################
  generatex1=function(){#generate x1 from fx()
    fy=sapply(x,fx)
    fmax=max(fy)
    xsample=runif(1,minu,maxu)
    ysample <- runif(1, 0, fmax)
	  while(fx(xsample) <ysample){
		  xsample=runif(1,minu,maxu)
		  ysample <- runif(1, 0, fmax)
	  }
    return(xsample)
  }

  generate=function(f,condx){#forward,generate one step ahead pseudo data from f(y|condx)
    ff=function(y) f(condx,y) 
    fy=sapply(u,ff)
    fmax=max(fy)
    xsample=runif(1,minu,maxu)
    ysample <- runif(1, 0, fmax)
	  while(ff(xsample) <ysample){
		  xsample=runif(1,minu,maxu)
		  ysample <- runif(1, 0, fmax)
	  }
    return(xsample)
  }

##################generate xstar forward#########################
  bootstrap=function(start){
	  ustar=rep(0,n)
	  ustar[1]=start
	  for (i in 1:(n-1)){
		  ustar[i+1]=generate(f,ustar[i])
	  }
	  list(ustar=ustar)
  }
##############generate xstar backward#####################
  bx=u[n:2]
  by=u[(n-1):1]
  bfx=function(a) sum(gauss((a - bx)/h)/((n-1)*h))
  bfxy=function(a,b) sum(gauss((a - bx)/h)*gauss((b-by)/h)/((n-1) * h^2))
  bf=function(a,b) bfxy(a,b)/bfx(a) #bf(b|a)

  bbootstrap=function(){
    ustar=rep(0,n)
    ustar[n]=u[n]
    for (i in 1:(n-1)){
      ustar[n-i]=generate(bf,ustar[n-i+1])
    }
    list(ustar=ustar)
  }
################generate 250 futurevalues and bootstrap replicates###################
  fvstarhat=rep(0,250)
  bfvstarhat=rep(0,250)
  fvstar=rep(0,250)
  for (i in 1:250){
    #forward
	  start=generatex1()
	  ustar=bootstrap(start)$ustar
	  xstar=ustar[1:(n-1)]
	  ystar=ustar[2:n]
	  fxstar=function(a) sum(gauss((a - xstar)/h)/((n-1)*h))
	  fxystar=function(a,b) sum(gauss((a - xstar)/h)*gauss((b-ystar)/h)/((n-1) * h^2))
	  fstar=function(a,b) fxystar(a,b)/fxstar(a) #f*(b|a)
	  xfstar=function(y) y*fstar(u[n],y)
	  fvstarhat[i]=as.numeric(integrate(Vectorize(xfstar),minu,maxu)[1])
	  #backward
	  ustar=bbootstrap()$ustar
	  xstar=ustar[1:(n-1)]
	  ystar=ustar[2:n]
	  fxstar=function(a) sum(gauss((a - xstar)/h)/((n-1)*h))
	  fxystar=function(a,b) sum(gauss((a - xstar)/h)*gauss((b-ystar)/h)/((n-1) * h^2))
	  fstar=function(a,b) fxystar(a,b)/fxstar(a) #f*(b|a)
	  xfstar=function(y) y*fstar(u[n],y)
	  bfvstarhat[i]=as.numeric(integrate(Vectorize(xfstar),minu,maxu)[1])
    #fvstar are same for backward and forward
	  fvstar[i]=generate(f,u[n])
  }

##########################coverage & intervel width#################################
  truevalue=rep(0,1000)
  for (i in 1:1000){
	  e=rlaplace(1,0,1/sqrt(2))
	  truevalue[i]=m(u[n])+v(u[n])*e
  }
  interval=fvstar-fvstarhat
  q=quantile(interval,c(0.025,.975))
  up=q[2]
  down=q[1]
  flength=up-down
  k=0
  for (i in 1:1000){
	  if((truevalue[i]<fvhat+up) & (truevalue[i]>fvhat+down))
		k=k+1
  }

  fc=k/1000

  q=quantile(interval,c(0.05,.95))
  up=q[2]
  down=q[1]
  flength90=up-down
  k=0
  for (i in 1:1000){
    if((truevalue[i]<fvhat+up) & (truevalue[i]>fvhat+down))
    k=k+1
  }
  fc90=k/1000

  binterval=fvstar-bfvstarhat
  q=quantile(binterval,c(0.025,.975))
  up=q[2]
  down=q[1]
  blength=up-down
  k=0
  for (i in 1:1000){
    if((truevalue[i]<fvhat+up) & (truevalue[i]>fvhat+down))
    k=k+1
  }
  bc=k/1000

  q=quantile(binterval,c(0.05,.95))
  up=q[2]
  down=q[1]
  blength90=up-down
  k=0
  for (i in 1:1000){
    if((truevalue[i]<fvhat+up) & (truevalue[i]>fvhat+down))
    k=k+1
  }
  bc90=k/1000

  #plot(density(truevalue-fvhat),type='l',main='bootstrap root vs true root_transition',xlab='root',ylab='density')
  #lines(density(fvstar-fvstarhat),col=2)
  #lines(density(binterval),col=3)

  list(fc=fc,bc=bc,fl=flength,bl=blength,fc90=fc90,bc90=bc90,fl90=flength90,bl90=blength90)
}



